/////////////////////////////////////////////////////////////////////////////
// 15.cpp: application implementation file



#include "stdafx.h"
#include "resource.h"

#include "15.h"
#include "dlg.h"

#include <time.h>	// beep, sleep & rand
#include <conio.h>	// beep
#include <stdio.h>	// rand
#include <stdlib.h>	// rand

/////////////////////////////////////////////////////////////////////////////

// theApp:
// Just creating this application object runs the whole application.
//
CTheApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////

// CMainWindow constructor:
// Create the window with the appropriate style, size, menu, etc.
//
CMainWindow::CMainWindow()
{
	// Main Window Style
	DWORD wndStyle = WS_VISIBLE|WS_OVERLAPPED|
					 WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX;

	// Calculate Window Size
	CRect wndRect;
	CClientDC dc(this);

	int wndWidth = 2*BORDER_WIDTH + 4*BUTTON_WIDTH;
	int wndHeight = 2*BORDER_WIDTH + 4*BUTTON_WIDTH;
	wndRect.left = (dc.GetDeviceCaps(HORZRES)-wndWidth)/2;
	wndRect.top = (dc.GetDeviceCaps(VERTRES)-wndHeight)/2;
	wndRect.right = wndRect.left + wndWidth;
	wndRect.bottom = wndRect.top + wndHeight;

	// Status Bar Height
	wndRect.bottom += BAR_HEIGHT;
	
	::AdjustWindowRect(&wndRect,wndStyle,TRUE);

	Create(NULL,
			"15! for Windows",
			wndStyle,
			wndRect,
			NULL,
			"MainMenu");
                        
	// Load Accelerator Table
	LoadAccelTable("MAINACCELTABLE");
	                        
	// Default = No Sound
	m_sound = FALSE;
}

void CMainWindow::StartGame()
{
	// Draw the Board
	CreateFrame();
	CreateTiles();
	DrawFrame();	       

	// Start a New Game
	OnGameNew();
}

void CMainWindow::CreateFrame()
{
	// Create the Border Buttons
	CRect rect;
	
	// Top-Left Corner
	rect.top = 0;
	rect.left = 0;
	rect.bottom = BORDER_WIDTH;
	rect.right = BORDER_WIDTH;
	m_gameArea[0][0] = new CBitmapButton;
	m_gameArea[0][0]->Create("caption",
		 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
		 					rect,
		 					this,
		 					ID_USER_SPACE);
    
	// Top Border
	rect.top = 0;
	rect.left = BORDER_WIDTH;
	rect.bottom = BORDER_WIDTH;
	rect.right = BORDER_WIDTH + BUTTON_WIDTH;
	for (int i=0; i<4; i++)
	{
		m_gameArea[0][i+1] = new CBitmapButton;
		m_gameArea[0][i+1]->Create("caption",
			 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
			 					rect,
		 						this,
		 						ID_USER_SPACE);
		rect.left += BUTTON_WIDTH;
		rect.right += BUTTON_WIDTH;
	}
	
	// Top-Right Corner
	rect.top = 0;
	rect.left = BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.bottom = BORDER_WIDTH;
	rect.right = rect.left + BORDER_WIDTH;
	m_gameArea[0][5] = new CBitmapButton;
	m_gameArea[0][5]->Create("caption",
		 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
		 					rect,
		 					this,
		 					ID_USER_SPACE);

	// Right Border
	rect.top = BORDER_WIDTH;
	rect.left = BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.bottom = rect.top + BUTTON_WIDTH;
	rect.right = rect.left + BORDER_WIDTH;
	for (i=0; i<4; i++)
	{
		m_gameArea[i+1][5] = new CBitmapButton;
		m_gameArea[i+1][5]->Create("caption",
			 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
			 					rect,
		 						this,
		 						ID_USER_SPACE);
		rect.top += BUTTON_WIDTH;
		rect.bottom += BUTTON_WIDTH;
	}
	
	// Bottom-Right Corner
	rect.top = BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.left = BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.bottom = 2*BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.right = 2*BORDER_WIDTH + 4*BUTTON_WIDTH;
	m_gameArea[5][5] = new CBitmapButton;
	m_gameArea[5][5]->Create("caption",
		 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
		 					rect,
		 					this,
		 					ID_USER_SPACE);

	// Bottom Border
	rect.top = BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.left = BORDER_WIDTH;
	rect.bottom = 2*BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.right = rect.left + BUTTON_WIDTH;
	for (i=0; i<4; i++)
	{
		m_gameArea[5][i+1] = new CBitmapButton;
		m_gameArea[5][i+1]->Create("caption",
			 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
			 					rect,
		 						this,
		 						ID_USER_SPACE);
		rect.left += BUTTON_WIDTH;
		rect.right += BUTTON_WIDTH;
	}
	
	// Bottom-Left Corner
	rect.top = BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.left = 0;
	rect.bottom = 2*BORDER_WIDTH + 4*BUTTON_WIDTH;
	rect.right = BORDER_WIDTH;
	m_gameArea[5][0] = new CBitmapButton;
	m_gameArea[5][0]->Create("caption",
		 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
		 					rect,
		 					this,
		 					ID_USER_SPACE);

	// Left Border
	rect.top = BORDER_WIDTH;
	rect.left = 0;
	rect.bottom = rect.top + BUTTON_WIDTH;
	rect.right = rect.left + BORDER_WIDTH;
	for (i=0; i<4; i++)
	{
		m_gameArea[i+1][0] = new CBitmapButton;
		m_gameArea[i+1][0]->Create("caption",
			 					WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
			 					rect,
		 						this,
		 						ID_USER_SPACE);
		rect.top += BUTTON_WIDTH;
		rect.bottom += BUTTON_WIDTH;
	}
}

void CMainWindow::CreateTiles()
{
	// Create all the Tiles Bitmap Buttons
	CRect rect;
	
	for (int i=1; i<5; i++)
		for (int j=1; j<5; j++)
		{
			rect.top = BORDER_WIDTH + (i-1)*BUTTON_WIDTH;
			rect.left = BORDER_WIDTH + (j-1)*BUTTON_WIDTH;
			rect.bottom = rect.top + BUTTON_WIDTH;
			rect.right = rect.left + BUTTON_WIDTH;
			
			m_gameArea[i][j] = new CBitmapButton;
			m_gameArea[i][j]->Create("caption",
		 							WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,
		 							rect,
		 							this,
		 							ID_USER_SPACE + (i-1)*4 + j);
		} 					  
}

void CMainWindow::DrawTiles()
{
	char buff[4];
	CString temp;
	CString res = "IDB_TILE";
	
	for (int i=0; i<4; i++)
		for (int j=0; j<4; j++)
		{
			if (m_gameTile[i][j]!=0)
			{
				temp = res;
				temp += _itoa(m_gameTile[i][j],buff,10);
				m_gameArea[i+1][j+1]->LoadBitmaps(temp+"U",temp+"D");
			}
			else
				m_gameArea[i+1][j+1]->LoadBitmaps("IDB_EMPTY");
			
			m_gameArea[i+1][j+1]->RedrawWindow();
		}
}

void CMainWindow::DrawFrame()
{
	// Top-Left Corner
	m_gameArea[0][0]->LoadBitmaps("IDB_BORDER_TL");
	m_gameArea[0][0]->RedrawWindow();
    
	// Top Border
	for (int i=0; i<4; i++)
	{
		m_gameArea[0][i+1]->LoadBitmaps("IDB_BORDER_HORZ");
		m_gameArea[0][i+1]->RedrawWindow();
	}
	
	// Top-Right Corner
	m_gameArea[0][5]->LoadBitmaps("IDB_BORDER_TR");
	m_gameArea[0][5]->RedrawWindow();

	// Right Border
	for (i=0; i<4; i++)
	{
		m_gameArea[i+1][5]->LoadBitmaps("IDB_BORDER_VERT");
		m_gameArea[i+1][5]->RedrawWindow();
	}
	
	// Bottom-Right Corner
	m_gameArea[5][5]->LoadBitmaps("IDB_BORDER_BR");
	m_gameArea[5][5]->RedrawWindow();

	// Bottom Border
	for (i=0; i<4; i++)
	{
		m_gameArea[5][i+1]->LoadBitmaps("IDB_BORDER_HORZ");
		m_gameArea[5][i+1]->RedrawWindow();
	}
	
	// Bottom-Left Corner
	m_gameArea[5][0]->LoadBitmaps("IDB_BORDER_BL");
	m_gameArea[5][0]->RedrawWindow();

	// Left Border
	for (i=0; i<4; i++)
	{
		m_gameArea[i+1][0]->LoadBitmaps("IDB_BORDER_VERT");
		m_gameArea[i+1][0]->RedrawWindow();
    }
}

void CMainWindow::DrawStatusBar()
{
	CClientDC DC(this);
	
	CRect barRect;
	GetClientRect(barRect);
	barRect.top = barRect.bottom - BAR_HEIGHT;
    
	// Grey Background
	CBrush grayBrush;     
	grayBrush.CreateSolidBrush(RGB(0xc0,0xc0,0xc0));
	CBrush* pOldBrush = DC.SelectObject(&grayBrush);
	DC.Rectangle(barRect);
	DC.SelectObject(pOldBrush);
	grayBrush.DeleteObject();	
	
	// Draw 3D Frame
	CPen lightPen, darkPen;                         
	darkPen.CreatePen(PS_SOLID,MM_TEXT,RGB(0x80,0x80,0x80));	// Dark Grey
	lightPen.CreatePen(PS_SOLID,MM_TEXT,RGB(0xff,0xff,0xff));	// White
	
	DC.MoveTo(barRect.right,barRect.top);
	CPen* pOldPen;

	pOldPen = DC.SelectObject(&lightPen);
	DC.LineTo(barRect.left,barRect.top);			
	DC.LineTo(barRect.left,barRect.bottom-1);			
		
	DC.SelectObject(&darkPen);
	DC.LineTo(barRect.right-1,barRect.bottom-1);			
	DC.LineTo(barRect.right-1,barRect.top);			

	DC.SelectObject(pOldPen);
	darkPen.DeleteObject();
	lightPen.DeleteObject();
}    

void CMainWindow::UpdateStatusBar()
{
	CClientDC DC(this);
	COLORREF oldBkColor = DC.SetBkColor(RGB(0xc0,0xc0,0xc0));
	COLORREF oldTxColor = DC.SetTextColor(RGB(0x00,0x00,0x00));
	
	CRect barRect;
	GetClientRect(barRect);
	barRect.top = barRect.bottom - BAR_HEIGHT;
	
	// Which Level?
	CString str = "Level: ";
	switch (m_level)
	{
		case BEGINNER		:	str += "B";
								break;
		case INTERMEDIATE	:	str += "I";
								break;
		case EXPERT			:	str += "E";
								break;
	}           
	
    DC.TextOut(barRect.left + LEFT_MARGIN,barRect.top + TOP_MARGIN,str);
    
	// Which Move?                
	str = "Move: ";
	char buff[6];
	str += _itoa(m_moves,buff,10);
	DC.TextOut((barRect.left+barRect.right)/2 + LEFT_MARGIN
										,barRect.top + TOP_MARGIN,str);
	
	DC.SetBkColor(oldBkColor);
	DC.SetTextColor(oldTxColor);
}

void CMainWindow::Beep(int frequency,int duration)
{
    int control;

    // If frequency is 0, Beep doesn't try to make a sound. It
    // just sleeps for the duration requested

    if (frequency)
    {
        // Prepare timer by sending 10111100 to port 43
        _outp(0x43,0xb6);

        // Divide input frequency by timer ticks per second and
        // write (byte by byte) to timer

        frequency = (unsigned)(1193180L / frequency);
        _outp(0x42,(char)frequency);
        _outp(0x42,(char)(frequency>>8));

        // Save speaker control byte
        control = inp(0x61);

        // Turn on the speaker (with bits 0 and 1)
        _outp(0x61,control|0x3);
    }

	Sleep((clock_t)duration);

    // Turn speaker back on if necessary
    if (frequency)
        _outp(0x61, control);
}

void CMainWindow::Sleep(clock_t wait)
{
    clock_t goal;

    goal = wait + clock();
    while(goal>clock())
        ;
}

// ***********
//  GAME Menu  
// ***********

void CMainWindow::OnGameNew()
{
	// Set Initial Tile Configuration
	for (int i=0; i<4; i++)
		for (int j=0; j<4; j++)
			m_gameTile[i][j] = 4*i + j + 1;
	m_gameTile[3][3] = 0;	

	m_moves = 0;

	// Draw Game Board
	DrawTiles();
	
	// Draw Status Bar
	DrawStatusBar();
	UpdateStatusBar();

	// Randomize the Tiles
	float dir, prevDir = -1.0;
	srand((unsigned)time(NULL));
	
	// Empty Tile Coordinates
	int row = 3;
	int col = 3;
	BOOL move;
	
	while (m_moves<m_level)	
	{
		move = FALSE;
		dir = ((float)rand())/RAND_MAX;

		// Try to Move Tile Up
		if ((dir<0.25) && (row>0)
			&& ((prevDir<0.25) || (prevDir>=0.5)))		
		{
			row--;
			move = TRUE;
		}
		
		// Try to Move Tile Down
		if ((!move) && (dir>=0.25)
			&& (dir<0.5) && (row<3) && (prevDir>0.25))	
		{
			row++;
			move = TRUE;
		}
		
		// Try to Move Tile Left
		if ((!move) && (dir>=0.5)
			&& (dir<0.75) && (col>0) && (prevDir<0.75))		
		{
			col--;
			move = TRUE;
		}
		
		// Try to Move Tile Right
		if ((!move) && (dir>=0.75) && (col<3)
			&& ((prevDir<0.5) || (prevDir>=0.75)))	
		{
			col++;
			move = TRUE;
		}
		
		if (move)  
		{
			// Don't Update Status Bar
			MoveTile(row,col,FALSE);
			prevDir = dir;
		}	
	}        
	
	// Reset Move Counter
	m_moves = 0;
}

void CMainWindow::OnGameLevelBeginner()
{
	m_level = BEGINNER;
	OnGameNew();
}

void CMainWindow::OnUpdateGameLevelBeginner(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_level==BEGINNER);
}

void CMainWindow::OnGameLevelIntermediate()
{
	m_level = INTERMEDIATE;
	OnGameNew();
}

void CMainWindow::OnUpdateGameLevelIntermediate(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_level==INTERMEDIATE);
}

void CMainWindow::OnGameLevelExpert()
{
	m_level = EXPERT;
	OnGameNew();
}

void CMainWindow::OnUpdateGameLevelExpert(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_level==EXPERT);
}

void CMainWindow::OnGameSoundon()
{
	m_sound = !m_sound;
}

void CMainWindow::OnUpdateGameSoundon(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_sound);
}

void CMainWindow::OnGameHighscores()
{
	CHiScores dlg;
	dlg.m_beginnerName = m_beginnerBestPlayer;
	dlg.m_beginnerMoves = m_beginnerBestMoves;
	dlg.m_intermediateName = m_intermediateBestPlayer;
	dlg.m_intermediateMoves = m_intermediateBestMoves;
	dlg.m_expertName = m_expertBestPlayer;
	dlg.m_expertMoves = m_expertBestMoves;
	dlg.DoModal();
}

void CMainWindow::OnGameExit()
{
	// Write Records
	AfxGetApp()->WriteProfileInt(RECORD_SECTION,
								 BESTMOVES_BEGINNER_ENTRY,
								 m_beginnerBestMoves);
    AfxGetApp()->WriteProfileString(RECORD_SECTION,
    								BESTPLAYER_BEGINNER_ENTRY,
    								m_beginnerBestPlayer);
	AfxGetApp()->WriteProfileInt(RECORD_SECTION,
								 BESTMOVES_INTERMEDIATE_ENTRY,
								 m_intermediateBestMoves);
    AfxGetApp()->WriteProfileString(RECORD_SECTION,
    								BESTPLAYER_INTERMEDIATE_ENTRY,
    								m_intermediateBestPlayer);
	AfxGetApp()->WriteProfileInt(RECORD_SECTION,
								 BESTMOVES_EXPERT_ENTRY,
								 m_expertBestMoves);
    AfxGetApp()->WriteProfileString(RECORD_SECTION,
    								BESTPLAYER_EXPERT_ENTRY,
    								m_expertBestPlayer);
	// Write Last Level
	AfxGetApp()->WriteProfileInt(LEVEL_SECTION,LEVEL_ENTRY,m_level);
	
	PostMessage(WM_CLOSE);
}

void CMainWindow::OnDestroy()
{
	// Destroy the buttons
	for (int i=0; i<=5; i++)
		for (int j=0; j<=5; j++)
	{		
		m_gameArea[i][j]->DestroyWindow();
		delete m_gameArea[i][j];	
	}
	
	CFrameWnd ::OnDestroy();
}



// ***********
//  HELP Menu  
// ***********

void CMainWindow::OnHelpRules()
{
	CRules dlg;
	dlg.DoModal();
}

void CMainWindow::OnHelpOptions()
{
	COptions dlg;
	dlg.m_beginnerMoves = BEGINNER;
	dlg.m_intermediateMoves = INTERMEDIATE;
	dlg.m_expertMoves = EXPERT;
	dlg.DoModal();	
}

void CMainWindow::OnHelpAbout()
{
	CDialog about("AboutBox",this);
	about.DoModal();

	DrawStatusBar();
	UpdateStatusBar();
}



BOOL CMainWindow::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if ((wParam>=ID_USER_SPACE)
		&& (wParam<ID_USER_SPACE + 17))
	{
		wParam -= (ID_USER_SPACE + 1);
		int row = (wParam / 4);
		int col = (wParam % 4);
	
		if (m_gameTile[row][col]!=0)
			MoveTile(row,col);
			
		return TRUE;
	}	
	else
		return CFrameWnd::OnCommand(wParam,lParam);
}

void CMainWindow::MoveTile(int row, int col, BOOL showMove)
{
	int freeRow = -1;
	int freeCol = -1;
	
	// Free Space on the Left?
	if ((col>0) && (m_gameTile[row][col-1])==0)
	{
		freeRow = row;
		freeCol = col-1;
	}

	// Free Space on the Right?
	if ((col<3) && (m_gameTile[row][col+1])==0)
	{
		freeRow = row;
		freeCol = col+1;
	}

	// Free Space Up?
	if ((row>0) && (m_gameTile[row-1][col])==0)
	{
		freeRow = row-1;
		freeCol = col;
	}

	// Free Space Down?
	if ((row<3) && (m_gameTile[row+1][col])==0)
	{
		freeRow = row+1;
		freeCol = col;
	}

	if ((freeRow==-1) || (freeCol==-1))
	{
		if (m_sound)
			Beep(220,250);	// A

		AfxMessageBox("Tile isn't free",MB_ICONEXCLAMATION);
	}
	else
	{
		// Move Tile
		m_moves++;
		
		// Update Moves Scoring
		if (showMove)
			UpdateStatusBar();
		
		if (m_sound)
			MessageBeep(-1);
		
		char buff[3];
		CString res = "IDB_TILE";
		res += _itoa(m_gameTile[row][col],buff,10);
		m_gameArea[freeRow+1][freeCol+1]->LoadBitmaps(res+"U",res+"D"); 
		m_gameArea[freeRow+1][freeCol+1]->RedrawWindow(); 

		m_gameArea[row+1][col+1]->LoadBitmaps("IDB_EMPTY"); 
		m_gameArea[row+1][col+1]->RedrawWindow(); 

		m_gameTile[freeRow][freeCol] = m_gameTile[row][col];
		m_gameTile[row][col] = 0;

		int i = 0;
		BOOL sorted = TRUE;
		while ((sorted) && (i<15))
		{
			row = i / 4;
			col = i % 4;
			sorted = (m_gameTile[row][col]==(i+1));
			i++;
		}
		
		if (sorted)                 
		{
			// New Record?
			if (((m_level==BEGINNER) && (m_moves<m_beginnerBestMoves))
				|| ((m_level==INTERMEDIATE) && (m_moves<m_intermediateBestMoves))
				|| ((m_level==EXPERT) && (m_moves<m_expertBestMoves)))
			{				
				if (m_sound)
				{
					Beep(880,100);	// A
					Beep(1046,900);	// C
				}
				
				UpdateHiScores();
			}
			
			if (m_sound)
				Beep(880,250);	// A
		
			if (AfxMessageBox("Well done!\nAnother game?",MB_YESNO|MB_ICONQUESTION)==IDNO)
				OnGameExit();
			else
				OnGameNew();	
		}		
	}	
}
    
void CMainWindow::UpdateHiScores()
{	
	switch (m_level)
	{
		case BEGINNER		:	{
									m_beginnerBestMoves = m_moves;
								    CAskName dlg;
								    dlg.DoModal();
								    m_beginnerBestPlayer = dlg.m_name;
									break;
								}	
		case INTERMEDIATE	:   {
									m_intermediateBestMoves = m_moves;
								    CAskName dlg;
								    dlg.DoModal();
								    m_intermediateBestPlayer = dlg.m_name;
									break;
								}	
		case EXPERT			:   {
									m_expertBestMoves = m_moves;
								    CAskName dlg;
								    dlg.DoModal();
								    m_expertBestPlayer = dlg.m_name;
									break;
								}	
	}           
	
	// Show HiScores Table
	OnGameHighscores();
}

void CMainWindow::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	// Redraw the Status Bar
	DrawStatusBar();
	UpdateStatusBar();
	
	CRect barRect;
	GetClientRect(barRect);
	barRect.top = barRect.bottom - BAR_HEIGHT;
    
	ValidateRect(barRect);
}

// CMainWindow message map:
// Associate messages with member functions.

BEGIN_MESSAGE_MAP( CMainWindow, CFrameWnd )
	//{{AFX_MSG_MAP( CMainWindow )
	ON_COMMAND(ID_GAME_NEW, OnGameNew)
	ON_COMMAND(ID_GAME_EXIT, OnGameExit)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP_RULES, OnHelpRules)
	ON_COMMAND(ID_GAME_LEVEL_BEGINNER, OnGameLevelBeginner)
	ON_COMMAND(ID_GAME_LEVEL_EXPERT, OnGameLevelExpert)
	ON_COMMAND(ID_GAME_LEVEL_INTERMEDIATE, OnGameLevelIntermediate)
	ON_UPDATE_COMMAND_UI(ID_GAME_LEVEL_BEGINNER, OnUpdateGameLevelBeginner)
	ON_UPDATE_COMMAND_UI(ID_GAME_LEVEL_EXPERT, OnUpdateGameLevelExpert)
	ON_UPDATE_COMMAND_UI(ID_GAME_LEVEL_INTERMEDIATE, OnUpdateGameLevelIntermediate)
	ON_COMMAND(ID_GAME_HIGHSCORES, OnGameHighscores)
	ON_COMMAND(ID_GAME_SOUNDON, OnGameSoundon)
	ON_UPDATE_COMMAND_UI(ID_GAME_SOUNDON, OnUpdateGameSoundon)
	ON_WM_PAINT()
	ON_COMMAND(ID_HELP_OPTIONS, OnHelpOptions)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()





/////////////////////////////////////////////////////////////////////////////
// CTheApp

BOOL CTheApp::InitInstance()
{
	// White BackGround
	SetDialogBkColor(RGB(0xff,0xff,0xff));
	
	m_pMainWnd = new CMainWindow();
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();

	// Load Hi Scores
    ((CMainWindow*)m_pMainWnd)->m_beginnerBestMoves =
    		GetProfileInt(RECORD_SECTION,BESTMOVES_BEGINNER_ENTRY,BESTMOVES_BEGINNER);
    ((CMainWindow*)m_pMainWnd)->m_beginnerBestPlayer =
    		GetProfileString(RECORD_SECTION,BESTPLAYER_BEGINNER_ENTRY,BESTPLAYER_BEGINNER);
    
    ((CMainWindow*)m_pMainWnd)->m_intermediateBestMoves =
    		GetProfileInt(RECORD_SECTION,BESTMOVES_INTERMEDIATE_ENTRY,BESTMOVES_INTERMEDIATE);
    ((CMainWindow*)m_pMainWnd)->m_intermediateBestPlayer =
    		GetProfileString(RECORD_SECTION,BESTPLAYER_INTERMEDIATE_ENTRY,BESTPLAYER_INTERMEDIATE);
    
    ((CMainWindow*)m_pMainWnd)->m_expertBestMoves =
    		GetProfileInt(RECORD_SECTION,BESTMOVES_EXPERT_ENTRY,BESTMOVES_EXPERT);
    ((CMainWindow*)m_pMainWnd)->m_expertBestPlayer =
    		GetProfileString(RECORD_SECTION,BESTPLAYER_EXPERT_ENTRY,BESTPLAYER_EXPERT);
    
    // Load Last Level
    ((CMainWindow*)m_pMainWnd)->m_level =
    		GetProfileInt(LEVEL_SECTION,LEVEL_ENTRY,DEFAULT_LEVEL);
    
	// Start a new Game
	((CMainWindow*)m_pMainWnd)->StartGame();
    return TRUE;
}    




